// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Fernando ALMEIDA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef ACTGEN_PASS_PLAYER_H
#define ACTGEN_PASS_PLAYER_H

#include "action_generator.h"

#include <vector>

/*!
  \brief Generate possible passses between 2 players
  */
class ActGen_PassPlayer
    : public ActionGenerator {

public:
    ActGen_PassPlayer(unsigned int from, unsigned int to);

    virtual
    ~ActGen_PassPlayer();

    virtual
    void generate( std::vector< ActionStatePair > * result,
                   const PredictState & state,
                   const rcsc::WorldModel & current_wm,
                   const std::vector< ActionStatePair > & path ) const;

private:
    unsigned int M_from;
    unsigned int M_to;
};

#endif // ACTGEN_PASS_PLAYER_H
