// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "role_center_forward.h"


#include <chain_action/bhv_chain_action.h>
#include <behaviors/bhv_basic_offensive_kick.h>
#include <behaviors/bhv_basic_move.h>

// #include <rcsc/player/player_agent.h>
#include <fcportugal_player.h>
#include <rcsc/player/debug_client.h>
#include <rcsc/player/intercept_table.h>

#include <rcsc/common/logger.h>

using namespace rcsc;

const std::string RoleCenterForward::NAME( "CenterForward" );

/*-------------------------------------------------------------------*/
/*!

 */
namespace {
rcss::RegHolder role = SoccerRole::creators().autoReg( &RoleCenterForward::create,
                                                       RoleCenterForward::NAME );
}

/*-------------------------------------------------------------------*/
/*!

 */
bool
RoleCenterForward::execute( PlayerAgent * agent )
{
    bool kickable = agent->world().self().isKickable();
    if ( agent->world().existKickableTeammate()
         && agent->world().teammatesFromBall().front()->distFromBall()
         < agent->world().ball().distFromSelf() )
    {
        kickable = false;
    }

    if ( kickable )
    {
        FCPortugalPlayer* fcp_agent = static_cast<FCPortugalPlayer*>( agent );
        if ( fcp_agent->setplayInterpreter().hasActiveSetplay() )
        {
            dlog.addText( Logger::ACTION,
                          __FILE__ " %s Not kicking the ball to not interfere with ongoing set-play!",
                          NAME.c_str());
            doMove( agent );
        }
        else
        {
            doKick( agent );
        }
    }
    else
    {
        doMove( agent );
    }

    return true;
}

/*-------------------------------------------------------------------*/
/*!

 */
void
RoleCenterForward::doKick( PlayerAgent * agent )
{
    if ( Bhv_ChainAction().execute( agent ) )
    {
        dlog.addText( Logger::TEAM,
                      __FILE__": (execute) do chain action" );
        agent->debugClient().addMessage( "ChainAction" );
        return;
    }

    Bhv_BasicOffensiveKick().execute( agent );
}

/*-------------------------------------------------------------------*/
/*!

 */
void
RoleCenterForward::doMove( PlayerAgent * agent )
{
    // Fastest player to ball
    /* if const WorldModel& world = agent->world();
    const PlayerObject* bowner = world.interceptTable()->teammateReachCycle() < world.interceptTable()->opponentReachCycle()
                                    ? world.interceptTable()->fastestTeammate()
                                    : world.interceptTable()->fastestOpponent();

     ( bowner != NULL && bowner->side() == world.ourSide() && !bowner->isSelf() &&
         world.interceptTable()->secondTeammate()->isSelf() )
    {
        rcsc::Vector2D ball_intercept_pos = world.ball().inertiaPoint( world.interceptTable()->teammateReachCycle( ) );
        AngleDeg ball_direction = world.ball().vel().dir();

        // Predict opponents closest to ball position assuming same vector


        world.interceptTable()->secondOpponent()->playerTypePtr()->realSpeedMax();

    } */

    Bhv_BasicMove().execute( agent );
}
