// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef SETPLAY_TRAINER_H
#define SETPLAY_TRAINER_H

#include <rcsc/trainer/trainer_agent.h>

class SetplayTrainer
    : public rcsc::TrainerAgent {
private:

public:

    SetplayTrainer();

    virtual
    ~SetplayTrainer();


    void runTestCase(unsigned int setplay_id);


protected:

    /*!
      You can override this method.
      But you must call TrainerAgent::doInit() in this method.
    */
    virtual
    bool initImpl( rcsc::CmdLineParser & cmd_parser );

    //! main decision
    virtual
    void actionImpl();

private:

    void sampleAction();
    void recoverForever();
    void doSubstitute();
    void doKeepaway();

};

class Setplay;

class TestCase {
public:
    TestCase();

private:
    unsigned int M_setplay_id;
    unsigned int M_num_runs;
};

class TestCaseGenerator {
public:

    void generateTestCases(const Setplay& setplay);
};

class TestSuite {
public:
    TestSuite();

    /*!
      \brief Load a definition of a test suite
      \param filename The name of the file that contains the test suite definition
      \returns True if the test suite is parsed properly, or false otherwise
      */
    bool load(const std::string& filename);

    /*!
      \brief Load a definition of a test suite
      \param filename The name of the file that contains the test suite definition
      \returns True if the test suite is parsed properly
      */
    bool save(const std::string& filename);

private:
    unsigned int M_num_tests;
    std::list<TestCase> M_test_cases;
};

class TestData {

private:
    // Initialize set-play parameters

};


#endif
