#include "test_case_generator.h"

#include <setplay/model/setplay.h>
#include <setplay/model/conditions.h>

using namespace setplay;

TestCaseGenerator::TestCaseGenerator()
{

}


std::vector<TestCase> TestCaseGenerator::generateTestCases(const Setplay& setplay,
                                                           unsigned int num_test_cases)
{
    /// Instantiate variables that allow the start condition of a set-play to be true

    /// Enable the set-play to start condition to be true
    const ICondition* start_condition = setplay.firstStep()->startCondition();


    /// Does the set-play have parameters?
    if ( setplay.hasParameters() )
    {
        // Determine the types of parameters and afterwards their instantiation

        return;
    }

    /// Check for each players if they have a position in the first step
    const Step* first_step = setplay.firstStep();


}

void TestCaseGenerator::analyzeCondition(const ICondition* condition)
{
    switch ( condition->type() )
    {
        case TT_CONDITION_AND:
        {
            const CondAnd* cond_and = static_cast<const CondAnd*>( condition );
            for ( Conditions::const_iterator itc = cond_and->conditions()->begin();
                  itc != cond_and->conditions()->end(); itc++)
            {
                analyzeCondition( *itc );
            }
        }
        break;
        case TT_CONDITION_OR:
        {
            const CondOr* cond_or = static_cast<const CondOr*>( condition );
            for ( Conditions::const_iterator itc = cond_or->conditions()->begin();
                  itc != cond_or->conditions()->end(); itc++)
            {
                analyzeCondition( *itc );
            }
        }
        break;
        case TT_CONDITION_NOT:
        {
            const CondNot* cond_not = static_cast<const CondNot*>( condition );
            analyzeCondition( cond_not->condition() );
        }
        break;
        case TT_CONDITION_BOOL:
        {

        }
        break;
        case TT_CONDITION_COMP_DECIMAL:
        {

        }
        break;
        case TT_CONDITION_OBJECT_LOCATION:
        {

        }
        break;
        case TT_CONDITION_TEAM_FORMATION:
        {

        }
        break;
        case TT_CONDITION_BALL_OWNER:
        {

        }
        break;
        case TT_CONDITION_TEAM_IN_POSSESSION:
        {

        }
        break;
        case TT_CONDITION_GAME_SITUATION:
        {

        }
        break;
        case TT_CONDITION_KICKABLE:
        {

        }
        break;
        case TT_CONDITION_OFFSIDE:
        {

        }
        case TT_CONDITION_CAN_INTERCEPT:
        {

        }
        break;
        case TT_CONDITION_CAN_SHOOT:
        {

        }
        break;
        case TT_CONDITION_CAN_PASS:
        {

        }
        break;
    }
}
