#ifndef STEP_ENTER_MESSAGE_H
#define STEP_ENTER_MESSAGE_H

#include <setplay/communication/imessage.h>

namespace setplay {

class StepEnterMessage
        : public IMessage
{
public:
    StepEnterMessage(const PlayerAffiliation& sender,
                     unsigned int time,
                     unsigned int setplayId,
                     unsigned int step_id = 0,
                     bool inverted = false);
    StepEnterMessage(const StepEnterMessage& other);
    ~StepEnterMessage();

    unsigned int stepId() const;
    void setStepId( unsigned int step_id );

    void getProcessed(IMessageProcessor& processor) const;

    MessageType type() const;
    IMessage* clone() const;

    void print(std::ostream& os) const;
private:
    unsigned int M_step_id;
};

}

#endif // STEP_ENTER_H
