// -*-c++-*-

/***************************************************************************
                                act_dribble.h
                       Abstract base class for CLang IIActions
                             -------------------
    begin                : 28-MAY-2002
    copyright            : (C) 2006 Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                        *
 *                                                                         *
 ***************************************************************************/
#ifndef SP_ACTION_DRIBBLE_H
#define SP_ACTION_DRIBBLE_H

#include <setplay/model/actions/iaction.h>
#include <setplay/model/geom/ilocation.h>


namespace setplay {

    // Dribble to region (argument).
    class ActDribble
            : public IAction {
    public:
        ActDribble(ILocation2D* location = NULL);
        ~ActDribble();

        TokenType type() const;
        ActionType actionType() const;

        ILocation2D *location() const;

        ActDribble& setLocation(ILocation2D* location);
        ActDribble& operator=(const ActDribble& other);

        void visit(IVisitor& visitor);

        ActDribble& operator*();
        ActDribble* clone() const;

    private:
        ILocation2D* M_location;
    };

}

#endif
