#include "act_intercept.h"

#include <setplay/model/ivisitor.h>


namespace setplay {

    ActIntercept::ActIntercept(IMobileObject *target)
        : M_target( target )
    {
        assert( target != NULL );
    }

    ActIntercept::ActIntercept(const ActIntercept& other)
        : M_target( other.M_target->clone() )
    {

    }

    ActIntercept::~ActIntercept()
    {
        if( M_target != NULL) { delete M_target; }
    }

    TokenType ActIntercept::type() const
    {
        return TT_ACTION_INTERCEPT;
    }

    IAction::ActionType ActIntercept::actionType() const
    {
        return AT_INTERCEPT;
    }

    IMobileObject* ActIntercept::target() const
    {
        return M_target;
    }

    ActIntercept& ActIntercept::setTarget(IMobileObject* target)
    {
        if ( M_target != NULL ) { delete M_target; }
        M_target = target;
        return *this;
    }

    ActIntercept& ActIntercept::operator=(const ActIntercept& other)
    {
      if (this != &other)
      {
          // TODO Who does the cleanup ?
          setTarget( other.M_target != NULL ? other.M_target->clone() : NULL);
      }

      return *this;
    }

    ActIntercept& ActIntercept::operator*()
    {
        return *this;
    }

    ActIntercept* ActIntercept::clone() const
    {
        return new ActIntercept(*this);
    }

    void ActIntercept::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

}
