#ifndef ACT_LOOK_AT_H
#define ACT_LOOK_AT_H

#include <vector>
#include <setplay/model/actions/iaction.h>
#include <setplay/model/participants/iplayer.h>

namespace setplay {

class ActLookAt
        : public IAction
{
public:
    ActLookAt( std::vector<IPlayer*> players );
    ActLookAt( IPlayer* player );
    ActLookAt( const ActLookAt& other );
    ~ActLookAt();

    TokenType type() const;
    ActionType actionType() const;
    ActLookAt& operator*();

    const std::vector<IPlayer*>& players() const;

    ActLookAt* clone() const;
    void visit(IVisitor &visitor);

private:
    std::vector<IPlayer*> M_players;
};

}

#endif // ACT_LOOK_AT_H
