// -*-c++-*-

/***************************************************************************
                                act_pos.h
                       Abstract base class for CLang Actions
                             -------------------
    begin                : 28-MAY-2002
    copyright            : (C) 2006 Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                        *
 *                                                                         *
 ***************************************************************************/
#ifndef SP_ACTION_POS_H
#define SP_ACTION_POS_H

#include <setplay/model/actions/iaction.h>

using namespace std;

namespace setplay {
    class IPlayer;
    class ILocation2D;

    // Position the player in a region (argument)
    class ActPos: public IAction {
    public:
            ActPos( ILocation2D*  r );
            ActPos( const ActPos& action );

            virtual ~ActPos();

            TokenType type() const;
            ActionType actionType() const;

            // 17/06/11 FA - Used to hold the relevant target center point, calculated only the first time the action is called or
            /*const Point2D* getCenterPoint(const IWorldModel* world) {
              return region->getCentralPoint(world);
            }*/

            ILocation2D *location() const;


            ActPos& setLocation(ILocation2D* location);


            ActPos& operator*();
            ActPos* clone() const;

            ActPos& operator=(const ActPos& other);

            void visit(IVisitor& visitor);

    private:
            ILocation2D* M_location;
    };

}

#endif
