// -*-c++-*-

/***************************************************************************
                                   cond_and.h  
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef SP_COND_AND_H
#define SP_COND_AND_H

#include <setplay/model/conditions/icondition.h>

namespace setplay {

        class IConditionEvaluator;
        class IVisitor;

        class IPlayer;

	    // Composite condition: logical and
        class CondAnd
                : public ICondition
	    {
        public:
              CondAnd(Conditions* conditions = NULL);
              CondAnd(const CondAnd& other);

              virtual ~CondAnd();

              TokenType type() const;

              // 14/06/11 FA Removed constness of function to allow modification of internal structures
              inline Conditions* conditions() const
              {
                  return M_conditions;
              }

              void push(ICondition* condition);
              void push(Conditions* conditions);

              CondAnd& operator=(const CondAnd& other);

              void visit(IVisitor& visitor);
              CondAnd* clone() const;
              CondAnd& operator*();

        private:
              Conditions* M_conditions;
	    };

}
#endif

