#include "cond_ball_owner.h"

#include <setplay/runtime/icondition_evaluator.h>
#include "../participants.h"
#include <setplay/model/ivisitor.h>

namespace setplay {

    CondBallOwner::CondBallOwner(IPlayer *player)
        : M_player(player)
    {

    }

    CondBallOwner::CondBallOwner(const CondBallOwner& other)
    {
        M_player = other.M_player != NULL ? other.M_player->clone() : NULL;
    }

    CondBallOwner::~CondBallOwner()
    {

    }

    TokenType CondBallOwner::type() const
    {
        return TT_CONDITION_BALL_OWNER;
    }

    IPlayer *CondBallOwner::player() const
    {
        return M_player;
    }

    CondBallOwner& CondBallOwner::setPlayer(IPlayer* player)
    {
        if ( M_player != NULL ) { delete M_player; }
        M_player = player;
    }


    CondBallOwner& CondBallOwner::operator=(const CondBallOwner& other)
    {
        if (this != &other)
        {
            this->M_player = other.M_player->clone();
        }
        return *this;
    }


    void CondBallOwner::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

    CondBallOwner* CondBallOwner::clone() const
    {
        return new CondBallOwner(*this);
    }

    CondBallOwner& CondBallOwner::operator*()
    {
        return *this;
    }

}
