// -*-c++-*-

/***************************************************************************
                                   cond_ball_owner.h
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef SP_COND_BALL_OWNER_H_
#define SP_COND_BALL_OWNER_H_

#include <setplay/model/conditions/icondition.h>

namespace setplay {

    class IPlayer;
    class IConditionEvaluator;
    class IVisitor;

        // Ball possession by player(s)
        class CondBallOwner: public ICondition
        {
        public:
            CondBallOwner(IPlayer* player = NULL);
            CondBallOwner(const CondBallOwner& other);
            ~CondBallOwner();

            IPlayer *player() const;
            CondBallOwner& setPlayer(IPlayer* player);


            CondBallOwner& operator=(const CondBallOwner& other);

            TokenType type() const;
            CondBallOwner* clone() const;
            CondBallOwner& operator*();
            void visit(IVisitor& visitor);

        private:
            IPlayer* M_player;
        };

}

#endif
