#ifndef COND_CAN_DRIBBLE_H
#define COND_CAN_DRIBBLE_H

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/participants/iplayer.h>
#include <setplay/model/geom/ilocation.h>

namespace setplay {

class CondCanDribble
{
public:
    CondCanDribble(IPlayer* player = NULL, ILocation2D* location = NULL);
    CondCanDribble(const CondCanPass& other);
    ~CondCanDribble();

    TokenType type() const;

    IPlayer* player( ) const;
    ILocation2D* location( ) const;

    CondCanDribble& setPlayer(IPlayer* player);
    CondCanDribble& setLocation(ILocation2D* location);

    CondCanDribble* clone() const;
    CondCanDribble& operator*();
    void visit(IVisitor& visitor);
private:
    IPlayer* M_player;
    ILocation2D* M_location;
};

}
#endif // COND_CAN_DRIBBLE_H
