#include "cond_comp_decimal.h"

using namespace std;

namespace setplay {

    CondCompDecimal::CondCompDecimal( NumberComparatorOperationType type,
                                    IDecimal *operand_left,
                                    IDecimal *operand_right)
            : BinaryOperation( operand_left, operand_right )
            , M_type(type)
    {

    }
    CondCompDecimal::CondCompDecimal( const CondCompDecimal& other)
        : BinaryOperation(other)
        , M_type(other.M_type)
    {

    }

    CondCompDecimal::~CondCompDecimal()
    {

    }

    TokenType CondCompDecimal::type() const
    {
        return TT_CONDITION_COMP_DECIMAL;
    }

    NumberComparatorOperationType CondCompDecimal::operationType() const
    {
        return M_type;
    }

    CondCompDecimal* CondCompDecimal::clone() const
    {
        return new CondCompDecimal(*this);
    }

    CondCompDecimal& CondCompDecimal::operator*()
    {
        return *this;
    }

    void CondCompDecimal::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }


}
