// -*-c++-*-

/***************************************************************************
                                   cond_formation.h
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef SP_COND_FORMATION_H_
#define SP_COND_FORMATION_H_

#include <setplay/model/conditions/icondition.h>

#include <setplay/model/types.h>

using namespace std;

namespace setplay {

        class CondTeamFormation
                : public ICondition {
        public:
          typedef enum { F_433, F_442, F_424, F_434, F_451, F_541, F_640, F_244 } Formation;

          CondTeamFormation(Formation formation, TeamAffiliation team_affiliation);
          CondTeamFormation(const CondTeamFormation& other);
          ~CondTeamFormation();

          TeamAffiliation team_affiliation() const;
          Formation formation() const;

          TokenType type() const;

          CondTeamFormation* clone() const;
          CondTeamFormation& operator*();
          CondTeamFormation& operator=(const CondTeamFormation& other);

          void visit(IVisitor& visitor);

        private:
          Formation M_formation;
          TeamAffiliation M_team_affiliation;
        };

}

#endif
