#include "cond_kickable.h"

namespace setplay {

CondKickable::CondKickable(IPlayer* player)
    : M_player(player)
{

}

CondKickable::CondKickable(const CondKickable& other)
{
    M_player = other.M_player != NULL ? other.M_player->clone() : NULL;
}

CondKickable::~CondKickable()
{
    if ( M_player != NULL ) { delete M_player; }
}

TokenType CondKickable::type() const
{
    return TT_CONDITION_KICKABLE;
}

IPlayer* CondKickable::player() const
{
    return M_player;
}

CondKickable& CondKickable::setPlayer(IPlayer* player)
{
    if ( M_player != NULL ) { delete M_player; }
    M_player = player;
    return *this;
}

CondKickable& CondKickable::operator=(const CondKickable& other)
{
    if ( this != &other )
    {
        setPlayer( other.M_player != NULL ? other.M_player->clone() : NULL );
    }
    return *this;
}

void CondKickable::visit(IVisitor &visitor)
{
    visitor.visit( *this );
}

CondKickable* CondKickable::clone() const
{
    return new CondKickable( *this );
}

CondKickable& CondKickable::operator*()
{
    return *this;
}

}
