#include "cond_or.h"

#include <setplay/model/ivisitor.h>

using namespace std;

namespace setplay {


    CondOr::CondOr(Conditions* conds)
        : M_conditions(conds)
    {
        if ( M_conditions == NULL )
        {
            M_conditions = new Conditions();
        }
    }

    CondOr::CondOr(const CondOr& other)
    {
        M_conditions = new Conditions();
        push(other.M_conditions);
    }


    CondOr::~CondOr()
    {
        if ( M_conditions != NULL )
        {
            for( Conditions::iterator i = M_conditions->begin(); i != M_conditions->end(); ++i )
            {
                delete *i;
            }

            delete M_conditions;
        }
    }

    TokenType CondOr::type() const
    {
        return TT_CONDITION_OR;
    }

    Conditions *CondOr::conditions() const
    {
        return M_conditions;
    }

    CondOr& CondOr::operator=(const CondOr& other)
    {
        if (this != &other)
        {
            push(other.M_conditions);
        }
        return *this;
    }

    void CondOr::push(ICondition* condition)
    {
        M_conditions->push_back(condition);
    }

    void CondOr::push(Conditions* conditions)
    {
        for( Conditions::iterator i = M_conditions->begin();
             i != M_conditions->end();
             ++i )
        {
            delete *i;
        }

        for( Conditions::iterator i = conditions->begin();
             i != conditions->end();
             ++i )
        {
            M_conditions->push_back( (*i)->clone() );
        }
    }

    void CondOr::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

    CondOr* CondOr::clone() const
    {
        return new CondOr(*this);
    }

    CondOr& CondOr::operator*()
    {
        return *this;
    }

}
