#include "cond_team_possession.h"

#include <setplay/model/ivisitor.h>

namespace setplay {


CondTeamInPossession::CondTeamInPossession(TeamAffiliation team_in_possession)
    : M_team_in_possession( team_in_possession )
{

}

CondTeamInPossession::CondTeamInPossession(const CondTeamInPossession& other)
    : M_team_in_possession( other.M_team_in_possession )
{

}

TeamAffiliation CondTeamInPossession::teamInPossession() const
{
    return M_team_in_possession;
}

TokenType CondTeamInPossession::type() const
{
    return TT_CONDITION_TEAM_IN_POSSESSION;
}

void CondTeamInPossession::visit(IVisitor& visitor)
{
    visitor.visit( *this );
}

CondTeamInPossession* CondTeamInPossession::clone() const
{
    return new CondTeamInPossession( *this );
}

CondTeamInPossession& CondTeamInPossession::operator*()
{
    return *this;
}

}
