#ifndef SP_LINE_2D_H
#define SP_LINE_2D_H

#include "ilocation.h"
#include <rcsc/geom/line_2d.h>

namespace setplay
{
    class IVisitor;
    class IDecimal;

    /*!
        \class  Line2D
        \brief 2D straight line class

        Line Fomula: aX + bY + c = 0
    */

    class Line2D: public ILocation2D
    {
    public:
        Line2D(IDecimal* a = NULL, IDecimal* b = NULL, IDecimal* c = NULL);
        Line2D(const Line2D& other);
        ~Line2D();

        Line2D& operator*();
        Line2D* clone() const;

        TokenType type() const;
        LocationType locationType() const;

        IDecimal* a() const;
        IDecimal* b() const;
        IDecimal* c() const;

        Line2D& setA(IDecimal* value);
        Line2D& setB(IDecimal* value);
        Line2D& setC(IDecimal* value);

        Line2D& operator=(const Line2D& other);

        void visit(IVisitor& visitor);
    private:
        IDecimal* M_a;
        IDecimal* M_b;
        IDecimal* M_c;
    };

}


#endif // LINE_2D_H
