#include "location_var.h"


namespace setplay {

    /// VarLocation implementation
    VarLocation::VarLocation(const string& name)
        : Variable(name)
    {

    }

    VarLocation::VarLocation(const VarLocation& other)
        : Variable(other)
    {

    }

    TokenType VarLocation::type() const
    {
        return TT_VAR_LOCATION;
    }

    ILocation2D::LocationType VarLocation::locationType() const
    {
        return LT_VARIABLE;
    }

    VarLocation& VarLocation::operator*()
    {
        return *this;
    }

    VarLocation* VarLocation::clone() const
    {
        return new VarLocation( *this );
    }

    void VarLocation::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

    /// VarPoint implementation
    VarPoint::VarPoint(const string& name)
        : Variable(name)
    {

    }

    VarPoint::VarPoint(const VarPoint& other)
        : Variable(other)
    {

    }

    TokenType VarPoint::type() const
    {
        return TT_VAR_POINT;
    }

    ILocation2D::LocationType VarPoint::locationType() const
    {
        return LT_VARIABLE;
    }

    VarPoint& VarPoint::operator*()
    {
        return *this;
    }

    VarPoint* VarPoint::clone() const
    {
        return new VarPoint( *this );
    }

    void VarPoint::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

    /// VarRegion implementation
    VarRegion::VarRegion(const string& name)
        : Variable(name)
    {

    }

    VarRegion::VarRegion(const VarRegion& other)
        : Variable(other)
    {

    }

    TokenType VarRegion::type() const
    {
        return TT_VAR_REGION;
    }

    ILocation2D::LocationType VarRegion::locationType() const
    {
        return LT_VARIABLE;
    }

    VarRegion& VarRegion::operator*()
    {
        return *this;
    }

    VarRegion* VarRegion::clone() const
    {
        return new VarRegion( *this );
    }

    void VarRegion::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }
}
