#ifndef SP_POINT_2D_H
#define SP_POINT_2D_H

#include <setplay/model/geom/ipoint.h>
#include <setplay/model/numbers/number_var.h>

namespace setplay {
    class IDecimal;
    class IContextProvider;

    class Point2D
            : public IPoint2D
    {
        public:
          Point2D(IDecimal* x = NULL, IDecimal* y = NULL);

          // Define a copy constructor
          Point2D(const Point2D& other);
          ~Point2D();

          TokenType type() const;
          IDecimal *x() const;
          IDecimal* y() const;

          Point2D& setX(IDecimal* value);
          Point2D& setY(IDecimal* value);

          Point2D&
          operator=(const Point2D& other);

          Point2D& operator*();
          Point2D* clone() const;
          void visit(IVisitor& visitor);
        private:
          IDecimal* M_x;
          IDecimal* M_y;
    };

}

#endif
