#ifndef SP_REG_RECT_H
#define SP_REG_RECT_H

#include <setplay/model/geom/iregion.h>
#include <setplay/model/geom/ipoint.h>

namespace setplay {

        class Rect2D
                : public IRegion2D {
            public:
              Rect2D( IPoint2D* topLeft = NULL, IPoint2D* bottomRight = NULL);
              Rect2D( const Rect2D& other);
              ~Rect2D();

              inline TokenType type() const
              {
                  static TokenType type = TT_RECTANGLE;
                  return type;
              }

              IPoint2D* topLeft() const;
              IPoint2D* bottomRight() const;

              Rect2D& setTopLeft(IPoint2D* top_left);
              Rect2D& setBottomRight(IPoint2D* bottom_right);
              Rect2D& operator=(const Rect2D& other);

              Rect2D& operator*();
              Rect2D* clone() const;
              void visit(IVisitor& visitor);
            private:
              IPoint2D* M_top_left;
              IPoint2D* M_bottom_right;
        };

}

#endif
