#include "triangle_2d.h"

#include <setplay/model/ivisitor.h>

namespace setplay
{

    Triangle2D::Triangle2D(IPoint2D* a, IPoint2D* b, IPoint2D* c)
        : M_a(a)
        , M_b(b)
        , M_c(c)
    {

    }

    Triangle2D::Triangle2D(const Triangle2D& other)
    {
        M_a = other.M_a != NULL ? other.M_a->clone() : NULL;
        M_b = other.M_b != NULL ? other.M_b->clone() : NULL;
        M_c = other.M_c != NULL ? other.M_c->clone() : NULL;
    }

    Triangle2D::~Triangle2D()
    {
        if ( M_a != NULL ) { delete M_a; }
        if ( M_b != NULL ) { delete M_b; }
        if ( M_b != NULL ) { delete M_c; }
    }

    TokenType Triangle2D::type() const
    {
        return  TT_TRIANGLE;
    }

    IPoint2D* Triangle2D::a() const
    {
        return M_a;
    }

    IPoint2D* Triangle2D::b() const
    {
        return M_b;
    }

    IPoint2D* Triangle2D::c() const
    {
        return M_c;
    }

    Triangle2D& Triangle2D::setA(IPoint2D* point)
    {
        if ( M_a != NULL ) { delete M_a; }
        M_a = point;
        return *this;
    }

    Triangle2D& Triangle2D::setB(IPoint2D* point)
    {
        if ( M_b != NULL ) { delete M_b; }
        M_b = point;
        return *this;
    }

    Triangle2D& Triangle2D::setC(IPoint2D* point)
    {
        if ( M_c != NULL ) { delete M_c; }
        M_c = point;
        return *this;
    }

    Triangle2D& Triangle2D::operator=(const Triangle2D& other)
    {
        if ( this != &other )
        {
            setA( other.M_a != NULL ? other.M_a->clone() : NULL);
            setB( other.M_b != NULL ? other.M_b->clone() : NULL);
            setC( other.M_c != NULL ? other.M_c->clone() : NULL);
        }
        return *this;
    }

    Triangle2D& Triangle2D::operator*()
    {
        return *this;
    }

    Triangle2D* Triangle2D::clone() const
    {
        return new Triangle2D(*this);
    }

    void Triangle2D::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

}
