// -*-c++-*-

#ifndef SP_NUMBER_VAR_H
#define SP_NUMBER_VAR_H

#include <setplay/model/types.h>
#include <setplay/model/variable.h>

namespace setplay {

    class VarInteger
            : public IInteger
            , public Variable {
    public:
        VarInteger(const string name);
        VarInteger(const VarInteger& other);

        TokenType type() const;

        void visit(IVisitor& visitor);
        VarInteger* clone() const;
        VarInteger& operator*();
    };

    class VarDecimal
            : public IDecimal
            , public Variable {
    public:
        VarDecimal(const string name);
        VarDecimal(const VarDecimal& other);

        TokenType type() const;

        void visit(IVisitor& visitor);
        VarDecimal* clone() const;
        VarDecimal& operator*();
    };

}

#endif
