#include "scope.h"

#include <setplay/model/variable.h>

using namespace std;

namespace setplay {

GlobalScope::GlobalScope()
{

}

const std::string& GlobalScope::name() const
{
    static string S_name = "global";
    return S_name;
}

inline IScope* GlobalScope::parent()
{
    return NULL;
}

bool GlobalScope::define(Symbol* sym)
{
    pair<map<string, Symbol*>::iterator, bool> res = M_symbols.insert(pair<string, Symbol*>(sym->name(), sym));
    return res.second;
}

Symbol* GlobalScope::resolve(std::string name)
{
    map<string, Symbol*>::iterator its = M_symbols.find(name);
    return its == M_symbols.end() ? NULL : its->second;
}

Scope::Scope(Object *owner_object, string name, IScope* parent)
    : M_owner_object(owner_object)
    , M_name(name)
    , M_parent(parent)
{
    assert( owner_object != NULL);
}

const std::string& Scope::name() const
{
    return M_name;
}

IScope* Scope::parent()
{
    return M_parent;
}

bool Scope::define(Symbol* sym)
{
    pair<map<string, Symbol*>::iterator, bool> res = M_symbols.insert(pair<string,Symbol*>(sym->name(), sym));
    return res.second;
}

Symbol* Scope::resolve(std::string name)
{
    map<string, Symbol*>::iterator its = M_symbols.find(name);
    if ( its == M_symbols.end() )
    {
        return M_parent == NULL ? NULL : M_parent->resolve(name);
    }
    return its->second;
}


}
