// -*-c++-*-
#ifndef SP_NEXT_STEP_H
#define SP_NEXT_STEP_H

#include <limits>
#include <setplay/model/transitions/itransition.h>

namespace setplay {
    class ICondition;

    class NextStep
            : public ITransition {
    public:
        NextStep( unsigned int nextStepId = std::numeric_limits<unsigned int>::max(),
                  ICondition* abortCondition = NULL,
                  ICondition* startCondition = NULL,
                  vector<IDirective*>* directives = NULL);
        NextStep(const NextStep&other);
      virtual ~NextStep();


      TokenType type() const;
      TransitionType transitionType() const;

      /// Accessors
      unsigned int nextStepId() const;
      ICondition* abortCondition() const;
      bool hasAbortCondition() const;

      /// Modifiers
      NextStep& setNextStepId(unsigned int next_step_id);
      NextStep& setAbortCondition(ICondition* condition);

      NextStep& operator=(const NextStep& other);

      void visit(IVisitor& visitor);
      NextStep* clone() const;
    private:
      unsigned int M_next_step_id;
      ICondition* M_abort_condition;
    };

}

#endif
