#include "variable.h"

namespace setplay {

Symbol::Symbol(string id, TokenType type, IScope *scope)
    : M_name( id )
    , M_type( type )
    , M_scope(scope)
{
    assert ( M_scope != NULL );
}

Symbol::Symbol(const Symbol& other)
    : M_name( other.M_name )
    , M_type( other.M_type )
{

}

Symbol::~Symbol()
{

}

// Accessors
const string& Symbol::name() const
{
    return M_name;
}

TokenType Symbol::type() const
{
    return M_type;
}

IScope* Symbol::scope()
{
    return M_scope;
}

void Symbol::setScope(IScope* scope)
{
    M_scope = scope;
}

bool Symbol::operator==(const Symbol& other)
{
    // Two symbols are the same if the have the same name, type and are defined in the same scope
    return M_name.compare(other.M_name) == 0 && M_type == other.M_type;
}


}
