#ifndef PLAN_H
#define PLAN_H

#include <vector>
#include "icondition.h"

using namespace std;

namespace setplay {

        template <typename Step, typename Participant>
        class Plan {
        public:
            typedef vector<Step*> Steps;
            typedef vector<Participant*> Participants;

            Plan(const vector<Participant*>* participants,
                 const vector<Step*>* steps,
                 const ICondition* wait_condition,
                 const ICondition* start_condition,
                 const ICondition* abort_condition)
                : M_participants(participants),
                  M_steps(steps),
                  M_wait_condition(wait_condition),
                  M_start_condition(start_condition),
                  M_abort_condition(abort_condition)
            {

            }

            Plan(const Plan& other)
                : M_participants(other.M_participants),
                  M_steps(other.M_steps),
                  M_wait_condition(other.M_wait_condition),
                  M_start_condition(other.M_start_condition),
                  M_abort_condition(other.M_abort_condition)
            {
                // TODO Complete initialization in a correct manner
            }

            unsigned int numParticipants() const
            {
                return M_participants->size();
            }

            const vector<Participant*>* participants() const
            {
                return M_participants;
            }

            const vector<Step*>* steps() const
            {
                return M_steps;
            }

            const ICondition* wait_condition() const
            {
                return M_wait_condition;
            }

            const ICondition* start_condition() const
            {
                return M_start_condition;
            }

            const ICondition* abort_condition() const
            {
                return M_abort_condition;
            }

        protected:
            const Participants* M_participants;
            const Steps* M_steps;
            const ICondition* M_wait_condition;
            const ICondition* M_start_condition;
            const ICondition* M_abort_condition;
        };

}

#endif // PLAN_H
