/*
 * File:   IContextObserver.h
 * Author: falmeida
 *
 * Created on May 31, 2011, 6:35 PM
 */

#ifndef SP_CONDITION_EVALUATOR_H
#define	SP_CONDITION_EVALUATOR_H

#include <vector>
#include <setplay/model/participants/player_affiliation.h>
#include <setplay/model/game_situation.h>
#include <rcsc/geom.h>

namespace setplay {

    class IConditionEvaluator
    {
    public:
        virtual ~IConditionEvaluator() { }

        virtual bool playerAtRegion( const PlayerAffiliation& player,
                                     const rcsc::Region2D& region ) = 0;
        virtual bool playerAtPosition( const PlayerAffiliation& player,
                                       const rcsc::Vector2D& position ) = 0;

        virtual bool ballAtRegion( const rcsc::Region2D& region ) = 0;
        virtual bool ballAtPosition( const rcsc::Vector2D& position ) = 0;

        virtual bool canPassToPlayer( const PlayerAffiliation& player1,
                                      const PlayerAffiliation& player2 )  = 0;
        virtual bool canPassToRegion( const PlayerAffiliation& player,
                                      const rcsc::Region2D& region )  = 0;
        virtual bool canPassToPosition( const PlayerAffiliation& player,
                                        const rcsc::Vector2D& position ) = 0;

        virtual bool isOffside( const PlayerAffiliation& player ) = 0;

        virtual bool canInterceptBall( const PlayerAffiliation& player ) = 0;

        virtual bool isBallKickable( const PlayerAffiliation& player ) = 0;
        virtual bool ownsBall( const PlayerAffiliation& player ) = 0;

        virtual bool isTeamInPossession ( const TeamAffiliation& affiliation ) = 0;

        virtual bool isGameSituation( const GameSituation& game_situation) = 0;

    }; // end IConditionEvaluator

}

#endif	/* SP_CONDITION_EVALUATOR_H */
