#ifndef ISETPLAY_EXECUTION_OBSERVER_H
#define ISETPLAY_EXECUTION_OBSERVER_H

#include <iostream>

namespace setplay {

/// Forward declaration of set-play interpreter
class SetplayInterpreter;

class ISetplayExecutionObserver
{
public:
    ~ISetplayExecutionObserver() { }

    /// Setplay events
    /* virtual void setplayStarted(const Setplay& step) = 0;
    virtual void setplayAborted(const Setplay& step) = 0;
    virtual void setplayFinished(const Setplay& step) = 0;

    /// Step events
    virtual void stepChosen(const Step& step) = 0;
    virtual void stepStarted(const Step& step) = 0;
    virtual void stepEnded(const Step& step) = 0;
    virtual void stepAborted(const Step& step) = 0;

    /// Transition events
    virtual void transitionChosen(const Step& step) = 0;
    virtual void transitionStarted(const Step& step) = 0;
    virtual void transitionEnded(const Step& step) = 0;
    virtual void transitionAborted(const Step& step) = 0;*/

    virtual void stateChanged( const SetplayInterpreter& interpreter ) = 0;
};

class SetplayExecutionObserver
        : public ISetplayExecutionObserver
{
public:
    SetplayExecutionObserver( std::ostream& os );
    void stateChanged( const SetplayInterpreter& interpreter );
private:
    std::ostream& M_os;
};

}

#endif // ISETPLAY_EXECUTION_OBSERVER_H
