#ifndef SETPLAY_SELECTOR_H
#define SETPLAY_SELECTOR_H

#include <setplay/model/setplay.h>
#include <setplay/runtime/player_selector.h>
#include <setplay/runtime/setplay_interpreter.h>
#include <setplay/runtime/setplay_database.h>

namespace setplay {

class SetplayMediator;
/*!
  \brief Algorithm for selecting set-plays to execute given a SetplayDatabase
  */
class ISetplaySelector
{
public:
    virtual ~ISetplaySelector() { }

    virtual bool selectSetplay( SetplayInterpreter& interpreter ) = 0;
};

class FirstFeasibleSetplaySelector
        : public ISetplaySelector
{
public:
    FirstFeasibleSetplaySelector();

    bool selectSetplay( SetplayInterpreter& interpreter );

    void setPlayerSelector( IPlayerSelector* player_selector );
    void setDatabase( const SetplayDatabase* database );
private:
    IPlayerSelector* M_player_selector;
    const SetplayDatabase* M_database;
};


/*class CbrSetplaySelector
        : public ISetplaySelector
{
public:
    CbrSetplaySelector();

    Setplay* selectSetplay(const SetplayMediator& sm );

private:
    static const float S_first_evaluation;

    double evaluate(const Setplay& setplay);

    ICaseEvaluator* M_case_evaluator;
    const CaseBase* M_historical_case_base;
    const CaseBase* M_game_case_base;
}; */

}

#endif // SETPLAY_SELECTOR_H
