#include "state_update_decider.h"

#include <setplay/runtime/setplay_interpreter.h>

namespace setplay {


bool AnyParticipantStateUpdater::canUpdateInterpreterState(const SetplayInterpreter& interpreter)
{
    const IWorldModel* world = interpreter.worldModel();
    PlayerAffiliation self( world->self(), TA_OUR );
    for ( Players::const_iterator itp = interpreter.currentSetplay()->players()->begin();
          itp != interpreter.currentSetplay()->players()->end(); itp++ )
    {
        PlayerAffiliation participant = interpreter.interpret( **itp );
        if ( self == participant )
        {
            return true;
        }
    }
    return false;
}

bool LeaderStateUpdater::canUpdateInterpreterState( const SetplayInterpreter& interpreter )
{
    PlayerAffiliation self = interpreter.self();

    if ( interpreter.hasNextStep() )
    {
        PlayerAffiliation next_step_leader = interpreter.nextStepLeader();
        return next_step_leader == self;
    }

    if  ( interpreter.hasCurrentStep() )
    {

        PlayerAffiliation step_leader = interpreter.currentStepLeader() ;
        return step_leader == self;
    }

    return false;
}

}
