#include "transition_selector.h"

namespace setplay {

FirstFeasibleTransitionSelector::FirstFeasibleTransitionSelector()
{

}

const ITransition* FirstFeasibleTransitionSelector::selectTransition( const SetplayInterpreter& interpreter )
{
    for (Transitions::const_iterator itt = interpreter.currentStep()->transitions()->begin();
         itt != interpreter.currentStep()->transitions()->end(); itt++ )
    {
        const ITransition* transition = *itt;
        if ( !transition->hasStartCondition() ||
             interpreter.interpret( *transition->startCondition() ))
        {
            return transition;
        }
    }

    return NULL;
}

}
