#include "ball_hold.h"
#include "ievent_visitor.h"

namespace soccer
{
	namespace event
	{

		BallHold::BallHold(unsigned int start_time, unsigned int end_time, PlayerId holder)
			: Event(start_time, end_time)
			, M_holder(holder)
		{

		}

        IEvent::EventType BallHold::type() const
        {
            return IEvent::BallHold;
        }

        const PlayerId &BallHold::holder() const
		{
			return M_holder;
		}

        void BallHold::visit(IEventVisitor& visitor) const
        {
            visitor.visit( *this );
        }

	}
}
