#ifndef BALL_HOLD_H
#define BALL_HOLD_H

#include <soccer/events/event.h>
#include <soccer/player_id.h>

namespace soccer 
{
	namespace event 
	{
	
		class BallHold: public Event {
		public:
            BallHold(unsigned int start_time,
                     unsigned int end_time,
                     PlayerId holder);

            EventType type() const;
            const PlayerId& holder() const;
			
            void visit(IEventVisitor& visitor) const;
		private:
			/// The player holding the ball
			PlayerId M_holder;
		};

	}
}
#endif // BALL_HOLD_H
