#include "corner_kick_taken.h"
#include "ievent_visitor.h"

namespace soccer
{
    namespace event
    {

        CornerKickTaken::CornerKickTaken(unsigned int start_time, TeamSide side)
            : Event(start_time)
            , M_side(side)
        {

        }


        IEvent::EventType CornerKickTaken::type() const
        {
            return IEvent::CornerKickTaken;
        }

        TeamSide CornerKickTaken::side() const
        {
            return M_side;
        }

        void CornerKickTaken::visit(IEventVisitor& visitor) const
        {
            visitor.visit( *this );
        }

    }
}
