#include <soccer/events/event.h>

#include <cassert>

namespace soccer {
        namespace event {
		
			Event::Event(unsigned int start_time)
				: IEvent()
				, M_start_time(start_time)
				, M_end_time(start_time) 
			{
				checkRep();
			}

			Event::Event(unsigned int start_time, unsigned int end_time) 
				: IEvent()
				, M_start_time(start_time)
				, M_end_time(end_time) 
			{
				checkRep();
			}

			unsigned int Event::startTime() const
			{
				return M_start_time;
			}
					
			unsigned int Event::endTime() const
			{
				return M_end_time;
			}		

			void Event::checkRep() const
			{
				assert ( M_end_time >= M_start_time );

			}

        }
}

