#include "event_chain.h"

using namespace std;
using namespace std::tr1;

namespace soccer {
namespace event {

EventChain::EventChain()
{

}

EventChain::EventChain( const std::vector< std::tr1::shared_ptr<IEvent> >& events)
    : vector( events )
{

}

EventChain::EventChain(const EventChain& event_chain)
    : vector( event_chain )
{

}

unsigned int EventChain::numEvents(EventType type)
{
    unsigned int count = 0;
    for ( const_iterator ite = begin(); ite != end(); ite++ )
    {
        if ( type == (*ite)->type() )
        {
            count++;
        }
    }
    return count;
}

unsigned int EventChain::startTime() const
{
    return front()->startTime();
}

unsigned int EventChain::endTime() const
{
    return back()->endTime();
}


}
}
