#include "free_kick_taken.h"
#include "ievent_visitor.h"

namespace soccer
{
    namespace event
    {

        FreeKickTaken::FreeKickTaken(unsigned int start_time, TeamSide side)
            : Event(start_time)
            , M_side(side)
        {

        }

        IEvent::EventType FreeKickTaken::type() const
        {
            return IEvent::FreeKickTaken;
        }

        TeamSide FreeKickTaken::side() const
        {
            return M_side;
        }

        void FreeKickTaken::visit(IEventVisitor& visitor) const
        {
            visitor.visit( *this );
        }

    }
}
