#include "player.h"

using namespace rcsc;

namespace soccer {

Player::Player(Unum number, TeamSide side,
               Vector2D position, Vector2D velocity,
               float body_dir, float neck_dir,
               bool goalie)
    : PlayerId(number, side)
    , IMovingObject(position, velocity)
	, M_body_dir(body_dir)
	, M_neck_dir(neck_dir)
	, M_goalie(goalie)
{

}

bool Player::isGoalie() const
{
    return M_goalie;
}

float Player::bodyDir() const
{
    return M_body_dir;
}

float Player::neckDir() const
{
    return M_neck_dir;
}

}
