/*
 * DMU.h
 *
 *  Created on: Mar 26, 2010
 *      Author: Luis Paulo Reis, Nima Shafii
 */

#ifndef DMU_H_
#define DMU_H_

#include "Strategy.h"
#include "HumanoidAgent.h"
#include "WorldState.h"
#include "Geometry.h"

class DMU: public Strategy
{
	friend class Singleton<WorldState>;
public:
	DMU();
	virtual ~DMU();

	Vector calculateTarget(Vector InitPos, Vector BallPos);
	float evaluate(Vector InitPos, Vector BallPos, Vector FinalPos);
	float evaluateFlux(Vector InitPos, Vector BallPos, Vector FinalPos);
	float evaluateSafe(Vector InitPos, Vector BallPos, Vector FinalPos);
	float evaluateEasy(Vector InitPos, Vector BallPos, Vector FinalPos);
	float interpolateFlux(Vector Position, Vector FluxSize, Vector FieldSize);

	Vector prevTarget, actTarget;
	float prevEval, actEval, actOri, prevOri;

};
typedef Singleton<DMU> SDMU;
#endif /* DMU_H_ */
