#ifndef FCPORTUGAL_FLUX_H
#define FCPORTUGAL_FLUX_H

#include <map>
#include <iostream>
#include <fstream>
#include <string>

#include <rcsc/geom/vector_2d.h>

namespace soccer
{
    class IWorldModel;

    namespace flux
    {

            typedef enum {
                FT_Matrix2D = 1,
                FT_Delaunay = 2
            } FluxType;

            
            class Flux
            {
            public:

                // # Flux 1,Type 1 (old) - Types:Norm 1, Del 2 - Flux Description - Normal
                virtual ~Flux();


                virtual FluxType type() const = 0;

                virtual double value ( const rcsc::Vector2D& position ) const = 0;

                bool readFile(const std::string& file_name);
                virtual bool read(std::istream& is) = 0;

                /*!
                  \brief Update flux model based on the world state
                  \param world_model The world model from which to update the flux
                  */
                virtual void update( const IWorldModel* world_model ) = 0;
            };

            typedef std::map<unsigned int, flux::Flux*> FluxMatrices;
    }
}

#endif // FCPORTUGAL_FLUX_H
