#include "formation_sbsp.h"

#include <rcsc/common/server_param.h>
#include <strategy/util.h>
#include <sstream>

#include <league_config.h>

#include <soccer/iworld_model.h>
#include <soccer/iplayer_id.h>

using namespace rcsc;
using namespace soccer::strategy;
using namespace soccer;

namespace soccer
{

    namespace formation
    {


    FormationSBSP::FormationSBSP(unsigned int id)
        :Formation(id)
    {

    }


    FormationType FormationSBSP::type() const
    {
        return FT_SBSP;
    }


   Vector2D FormationSBSP::position(const Unum& number,
                                    const IWorldModel &) const
    {
        return M_positions.at(number);
    }


    bool FormationSBSP::read( std::istream & is )
    {
        // Read player positions
        if ( !readPlayersPositions(is) )
        {
            return false;
        }
        // Read player types
        if ( !Formation::readPlayerTypes(is) )
        {
            return false;
        }

        return true;
    }


    bool FormationSBSP::readPlayersPositions(std::istream& is)
    {
        // Initialize positions as invalid
        // TODO Must read number of positions first
        unsigned int num_players = 11;
        for (unsigned int i = 0; i < num_players; i++)
        {
            M_positions[i] = Vector2D::INVALIDATED;
        }

        std::istringstream istr(util::getNextLine(is));
        // Read players x-coordinates
        for ( unsigned int i = 0 ; i < num_players ; i++ )
        {
            istr >> M_positions[i].x;
        }

        istr.clear();
        istr.str(util::getNextLine(is));
        // Read players y-coordinates
        for ( unsigned int i = 0 ; i < num_players ; i++ )
        {
            istr >> M_positions[i].y;
        }
        return true;
    }



    }
}
