#ifndef SINGLETON_H
#define SINGLETON_H

template <typename T>
class Singleton
{
    public:
        static T& instance()
        {
           static T S_instance;
           return S_instance;
        }

        static const T& i()
        {
           return instance();
        }

    protected:
        Singleton() { }
        // ...
    private:
        Singleton(const Singleton&);
        Singleton& operator=(const Singleton&);
        // ...
};

#endif // SINGLETON_H
