#ifndef FCPORTUGAL_STRATEGY_TACTIC_CONFIG_H
#define FCPORTUGAL_STRATEGY_TACTIC_CONFIG_H

#include <strategy/options_config.h>

namespace soccer
{
    namespace strategy
    {

        class TacticConfig
                : public OptionsConfig<TacticConfig>
        {
        public:
            TacticConfig();

            // Tactics configurations
            bool useTactics() const;
            const std::string& tacticsDir() const;
            const std::vector<std::string>& tacticsFiles() const;
            int defaultTacticId() const;

            void print(std::ostream &os) const;
        private:
            // Tactics configuration
            static const bool USE_TACTICS;
            static const std::string TACTICS_DIR;
            static const int DEFAULT_TACTIC_ID;

            bool M_use_tactics;
            std::string M_tactics_dir;
            std::vector<std::string> M_tactics_files;
            int M_default_tactic_id;
        };

    }
}
#endif // FCPORTUGAL_STRATEGY_TACTIC_CONFIG_H
